diff --git a/contrib/ncurses/NEWS b/contrib/ncurses/NEWS
index 4203d188f7f4..8bedbc8264e1 100644
--- a/contrib/ncurses/NEWS
+++ b/contrib/ncurses/NEWS
@@ -380,7 +1545,7 @@ it is not possible to add this information.
 	+ re-enable "bel" in konsole-base (report by Nia Huang)
 	+ add linux-s entry (patch by Alexandre Montaron).
 	+ drop long-obsolete convert_configure.pl
-	+ add test/test_parm.c, for checking tparm changes.
+	+ add test/test_tparm.c, for checking tparm changes.
 	+ improve parameter-checking for tparm, adding function _nc_tiparm() to
 	  handle the most-used case, which accepts only numeric parameters
 	  (report/testcase by "puppet-meteor").
@@ -4598,7 +5763,7 @@ it is not possible to add this information.
 	  function pointer passed to tputs().
 	+ modify init_pair() to accept -1's for color value after
 	  assume_default_colors() has been called (Debian #337095).
-	+ modify test/background.c, adding commmand-line options to demonstrate
+	+ modify test/background.c, adding command-line options to demonstrate
 	  assume_default_colors() and use_default_colors().
 
 20110416
@@ -10333,7 +11498,7 @@ it is not possible to add this information.
 	+ add mgterm terminfo entry from NetBSD, minor adjustments to sun-ss5,
 	  aixterm entries -TD
 	+ modify tack/ansi.c to make it more tolerant of bad ANSI replies.  An
-	  example of an illegal ANSI resonse can be found using Microsoft's
+	  example of an illegal ANSI response can be found using Microsoft's
 	  Telnet client.  A correct display can be found using a VT-4xx
 	  terminal or XFree86 xterm with:
 		XTerm*VT100*decTerminalID:  450
@@ -11227,7 +12392,7 @@ it is not possible to add this information.
 	+ correct a typo in term.7 (Todd C Miller).
 	+ add configure --with-shlib-version option to allow installing shared
 	  libraries named according to release or ABI versions.  This
-	  parameterizes some existing logic in the configure script, and is
+	  parametrizes some existing logic in the configure script, and is
 	  intended for compatibility upgrades on Digital Unix, which used
 	  versioned libraries in ncurses 4.2, but no longer does (cf:  980425).
 	+ resync configure script against autoconf 2.13 + patches
diff --git a/contrib/ncurses/README b/contrib/ncurses/README
index a48e3f6155d9..5587f5b70bce 100644
--- a/contrib/ncurses/README
+++ b/contrib/ncurses/README
@@ -1,5 +1,5 @@
 -------------------------------------------------------------------------------
--- Copyright 2020 Thomas E. Dickey                                           --
+-- Copyright 2020-2021,2023 Thomas E. Dickey                                 --
 -- Copyright 1998-2012,2018 Free Software Foundation, Inc.                   --
 --                                                                           --
 -- Permission is hereby granted, free of charge, to any person obtaining a   --
@@ -26,7 +26,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: README,v 1.28 2020/02/02 23:34:34 tom Exp $
+-- $Id: README,v 1.31 2023/10/28 14:49:04 tom Exp $
 -------------------------------------------------------------------------------
 		README file for the ncurses package
 
@@ -35,18 +35,19 @@ See the file INSTALL for instructions on how to build and install ncurses.
 See the file NEWS for a release history and bug-fix notes.
 See the file TO-DO for things that still need doing, including known bugs.
 
-Browse the file misc/ncurses-intro.html for narrative descriptions of how
+Browse the file doc/html/ncurses-intro.html for narrative descriptions of how
 to use ncurses and the panel, menu, and form libraries.
- 
+
 Browse the file doc/html/hackguide.html for a tour of the package internals.
 
+Find plain text versions of both of these documents in doc/.
+
 ROADMAP AND PACKAGE OVERVIEW:
 
 You should be reading this file in a directory called:  ncurses-d.d, where d.d
 is the current version number (see the dist.mk file in this directory for
 that).  There should be a number of subdirectories, including `c++', `form',
-`man', `menu', `misc', `ncurses', `panel', `progs', `test', 'tack' and `Ada95'. 
-(The 'tack' program may be distributed separately).
+`man', `menu', `misc', `ncurses', `panel', `progs', `test', and `Ada95'.
 
 A full build/install of this package typically installs several libraries, a
 handful of utilities, and a database hierarchy.  Here is an inventory of the
@@ -81,7 +82,7 @@ version.
 
 If you configure using the --enable-reentrant option, a "t" is appended to the
 library names (e.g., libncursest.a) and the resulting libraries have a
-different binary interface which makes the ncurses interface more "opaque".
+different binary interface, making the ncurses interface more opaque.
 
 The ncurses libraries implement the curses API.  The panel, menu and forms
 libraries implement clones of the SVr4 panel, menu and forms APIs.  The source
@@ -89,9 +90,9 @@ code for these lives in the `ncurses', `panel', `menu', and `form' directories
 respectively.
 
 In the `c++' directory, you'll find code that defines an interface to the
-curses, forms, menus and panels library packaged as C++ classes, and a demo program in C++
-to test it.  These class definition modules are not installed by the 'make
-install.libs' rule as libncurses++.
+curses, forms, menus and panels library packaged as C++ classes, and a demo
+program in C++ to test it.  These class definition modules are not installed
+by the 'make install.libs' rule as libncurses++.
 
 In the `Ada95' directory, you'll find code and documentation for an
 Ada95 binding of the curses API, to be used with the GNAT compiler.
@@ -102,8 +103,8 @@ for documentation of the binding.
 
 To do its job, the ncurses code needs your terminal type to be set in the
 environment variable TERM (normally set by your OS; under UNIX, getty(1)
-typically does this, but you can override it in your .profile); and, it needs a
-database of terminal descriptions in which to look up your terminal type's
+typically does this, but you can override it in your .profile); and, it needs
+a database of terminal descriptions in which to look up your terminal type's
 capabilities.
 
 In older (V7/BSD) versions of curses, the database was a flat text file,
@@ -117,10 +118,10 @@ second form.
 In the `misc' directory, there is a text file terminfo.src, in editable
 terminfo format, which can be used to generate the terminfo binaries (that's
 what make install.data does).  If the package was built with the
---enable-termcap option enabled, and the ncurses library cannot find a terminfo
-description for your terminal, it will fall back to the termcap file supplied
-with your system (which the ncurses package installation leaves strictly
-alone).
+--enable-termcap option enabled, and the ncurses library cannot find a
+terminfo description for your terminal, it will fall back to the termcap file
+supplied with your system (which the ncurses package installation leaves
+strictly alone).
 
 The utilities are as follows:
 
@@ -149,7 +150,7 @@ help you systematically exercise the library functions.
 
 AUTHORS:
 
-Pavel Curtis: 
+Pavel Curtis:
 	wrote the original ncurses
 
 Zeyd M. Ben-Halim:
@@ -176,8 +177,8 @@ Eric S. Raymond:
 	xterm mouse support, and the ncurses test program.
 
 Juergen Pfeifer
-	The menu and form libraries, C++ bindings for ncurses, menus, forms and
-	panels, as well as the Ada95 binding.  Ongoing support for panel.
+	The menu and form libraries, C++ bindings for ncurses, menus, forms
+	and panels, as well as the Ada95 binding.  Ongoing support for panel.
 
 CONTRIBUTORS:
 
@@ -216,3 +217,5 @@ BUGS:
 	See the INSTALL file for bug and developer-list addresses.
 	The Hacker's Guide in the doc directory includes some guidelines
 	on how to report bugs in ways that will get them fixed most quickly.
+
+-- vile:txtmode fc=78
diff --git a/contrib/ncurses/README.emx b/contrib/ncurses/README.emx
index c48b312c1979..666eaec73647 100644
--- a/contrib/ncurses/README.emx
+++ b/contrib/ncurses/README.emx
@@ -1,5 +1,5 @@
 -------------------------------------------------------------------------------
--- Copyright 2020 Thomas E. Dickey                                           --
+-- Copyright 2020,2021 Thomas E. Dickey                                      --
 -- Copyright 1998-2006,2018 Free Software Foundation, Inc.                   --
 --                                                                           --
 -- Permission is hereby granted, free of charge, to any person obtaining a   --
@@ -26,7 +26,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: README.emx,v 1.11 2020/02/02 23:34:34 tom Exp $
+-- $Id: README.emx,v 1.12 2021/06/17 21:20:30 tom Exp $
 -- Author: Thomas Dickey
 -------------------------------------------------------------------------------
 
@@ -34,7 +34,7 @@ You can build ncurses on OS/2 in the EMX environment.  But you must build and
 acquire tools.  Not all of the tools distributed with EMX work properly, and
 some additional ones are required.
 
-First, the configure script distributed with ncurses will not run as-is in EMX. 
+First, the configure script distributed with ncurses will not run as-is in EMX.
 You can generate a new one if you have autoconf built for EMX.  You will need
 the EMX development tools, of course.  Get these programs to start:
 
@@ -65,7 +65,7 @@ may fix these problems:
 
 	+ I also built from sources (because the distributed binaries did not
 	  work) the cmp, diff programs.
-	  
+
 	  Other required utilities such as ar, cat, chmod, cp, gawk, grep, mv,
 	  ls, rm, mkdir, sed, sort and tr worked.
 
diff --git a/contrib/ncurses/VERSION b/contrib/ncurses/VERSION
index f8f03afcea5f..8ebef8fe8eb8 100644
--- a/contrib/ncurses/VERSION
+++ b/contrib/ncurses/VERSION
@@ -1 +1 @@
-5:0:10	6.2	20210220
+5:0:10	6.5	20240427
diff --git a/contrib/ncurses/announce.html.in b/contrib/ncurses/announce.html.in
index 84b9d4297de5..9889ef1bfb6c 100644
--- a/contrib/ncurses/announce.html.in
+++ b/contrib/ncurses/announce.html.in
@@ -1,7 +1,7 @@
 <!--
-  $Id: announce.html.in,v 1.99 2020/10/19 08:18:12 tom Exp $
+  $Id: announce.html.in,v 1.107 2024/04/27 16:45:27 tom Exp $
   ****************************************************************************
-  * Copyright 2018-2019,2020 Thomas E. Dickey                                *
+  * Copyright 2018-2023,2024 Thomas E. Dickey                                *
   *                                                                          *
   * Permission is hereby granted, free of charge, to any person obtaining a  *
   * copy of this software and associated documentation files (the            *
@@ -29,12 +29,10 @@
   ****************************************************************************
 -->
 <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">
-
 <html>
 <head>
   <meta name="generator" content=
-  "HTML Tidy for HTML5 for Linux version 5.2.0">
-
+  "HTML Tidy for HTML5 for Linux version 5.6.0">
   <title>Announcing ncurses @VERSION@</title>
   <link rel="author" href="mailto:bug-ncurses@gnu.org">
   <meta http-equiv="Content-Type" content=
@@ -57,7 +55,6 @@
   }
   </style>
 </head>
-
 <body>
   <h1 class="no-header">Announcing ncurses @VERSION@</h1>
 
@@ -140,28 +137,27 @@
 
   <blockquote>
     <p><a href=
-    "ftp://ftp.invisible-island.net/ncurses/">ftp://ftp.invisible-island.net/ncurses/</a>
+    "https://invisible-island.net/archives/ncurses/">https://invisible-island.net/archives/ncurses/</a>
     or<br>
     <a href=
     "https://invisible-mirror.net/archives/ncurses/">https://invisible-mirror.net/archives/ncurses/</a>&nbsp;.</p>
   </blockquote>
 
-  <p>It is also available via anonymous FTP at the GNU distribution
-  site</p>
+  <p>It is also available at the GNU distribution site</p>
 
   <blockquote>
     <p><a href=
-    "ftp://ftp.gnu.org/gnu/ncurses/">ftp://ftp.gnu.org/gnu/ncurses/</a>&nbsp;.</p>
+    "https://ftp.gnu.org/gnu/ncurses/">https://ftp.gnu.org/gnu/ncurses/</a>&nbsp;.</p>
   </blockquote>
 
   <h2><a name="h2-release-notes" id="h2-release-notes">Release
   Notes</a></h2>
 
   <p>These notes are for <span class="main-name">ncurses</span>
-  @VERSION@, released <strong>February 12, 2020</strong>.</p>
+  @VERSION@, released <strong>April 27, 2024</strong>.</p>
 
   <p>This release is designed to be source-compatible with
-  <span class="main-name">ncurses</span> 5.0 through 6.1; providing
+  <span class="main-name">ncurses</span> 5.0 through 6.4; providing
   extensions to the application binary interface (ABI). Although
   the source can still be configured to support the <span class=
   "main-name">ncurses</span> 5 ABI, the reason for the release is
@@ -173,292 +169,181 @@
   this announcement.</p>
 
   <p>The most <a href="#h3-bug-fixes">important
-  bug-fixes/improvements</a> dealt with user-defined capabilities
-  in terminal descriptions. The release notes also mention some
-  other bug-fixes, but are focused on new features and improvements
-  to existing features since <span class="main-name">ncurses</span>
-  6.1 release.</p>
+  bug-fixes/improvements</a> dealt with robustness issues. The
+  release notes also mention some other bug-fixes, but are focused
+  on new features and improvements to existing features since
+  <span class="main-name">ncurses</span> 6.4 release.</p>
 
   <h3><a name="h3-library" id="h3-library">Library improvements</a></h3>
 
   <h4><a name="h4-new-library" id="h4-new-library">New features</a></h4>
 
-  <p>There are several new features:</p>
+  <p>These are new features:</p>
 
   <ul>
     <li>
-      <p><a href=
-      "@HOMEPAGE@/man/form_field_opts.3x.html">O_EDGE_INSERT_STAY</a>
-      tells the form library to optionally delay cursor movement on
-      a field edge/boundary</p>
-    </li>
+      <p>The low-level terminfo and termcap interfaces are used
+      both by the higher-level curses library, as well as by many
+      applications.</p>
 
-    <li>
-      <p><a href=
-      "@HOMEPAGE@/man/form_field_opts.3x.html">O_INPUT_FIELD</a>
-      extension to form library allows a dynamic field to shrink if
-      the new limit is smaller than the current field size.</p>
-    </li>
+      <p>The functions which convert parameterized terminal
+      capability strings for output to the terminal
+      (<code>tiparm</code> and <code>tparm</code>) analyze the
+      capability string to determine which parameters are strings
+      (i.e., addresses), versus numbers (not addresses).</p>
 
-    <li>
-      <p>added <a href=
-      "@HOMEPAGE@/man/curs_memleaks.3x.html">exit_curses</a> and
-      <a href=
-      "@HOMEPAGE@/man/curs_memleaks.3x.html">exit_terminfo</a> to
-      replace internal symbols for leak-checking.</p>
-    </li>
-
-    <li>
-      <p>added <a href=
-      "@HOMEPAGE@/man/curs_trace.3x.html#h3-Functions">curses_trace</a>,
-      to replace trace().</p>
-    </li>
-  </ul>
+      <p>The library's analysis of a capability string may differ
+      from the calling application's design if environment
+      variables are used to point to an invalid terminal database.
+      This is a longstanding problem with <em>all</em>
+      implementations of terminfo, dating from the early 1980s.</p>
 
-  <p>Additionally, to improve performance other changes (and
-  extensions) are provided in this release:</p>
+      <p>Two new functions address this problem: by providing a
+      function which allows the calling application to tell ncurses
+      how many string-parameters to expect:</p>
 
-  <ul>
-    <li>
-      <p>mouse decoding now handles shift/control/alt logic when
-      decoding xterm's 1006 mode</p>
-    </li>
-
-    <li>
-      <p>ncurses now defines a limit for <a href=
-      "@HOMEPAGE@/man/curs_getstr.3x.html">wgetnstr</a>, <a href=
-      "@HOMEPAGE@/man/curs_get_wstr.3x.html">wgetn_wstr</a> when
-      length is negative or &ldquo;too large&rdquo;.</p>
-    </li>
-
-    <li>reordered loop-limit checks in <a href=
-    "@HOMEPAGE@/man/curs_insstr.3x.html">winsnstr</a> in case the
-    string has no terminating null and only the number of
-    characters is used.</li>
-
-    <li>
-      <p>there is now no buffer-size limit when reading the
-      <a href="@HOMEPAGE@/man/ncurses.3x.html#h3-TERMCAP"><tt>$TERMCAP</tt></a>
-      variable.</p>
-    </li>
-
-    <li>
-      <p>the <a href=
-      "@HOMEPAGE@/man/ncurses.3x.html#h3-TERMCAP"><tt>$TERMCAP</tt></a>
-      variable may be interpreted as a fallback to a terminfo
-      entry</p>
-    </li>
+      <ul>
+        <li><code>tiscan_s</code> helps applications check
+        formatting capabilities that would be passed to
+        <code>tiparm_s</code>.</li>
 
-    <li>
-      <p><a href=
-      "@HOMEPAGE@/man/curs_terminfo.3x.html#h3-Output-Functions"><tt>
-      mvcur</tt></a> now decides whether to use hard-tabs, using
-      <strong><tt>xt</tt></strong>, <strong><tt>tbc</tt></strong>
-      and <strong><tt>hts</tt></strong> as clues.</p>
+        <li><code>tiparm_s</code> provides applications a way to
+        tell ncurses what the expected parameters are for a
+        capability.</li>
+      </ul>
     </li>
 
     <li>
-      <p>extended colors are improved by modifying an internal call
-      to <a href=
-      "@HOMEPAGE@/man/curs_terminfo.3x.html#h3-Output-Functions"><tt>
-      vid_puts</tt></a> to pass extended color pairs e.g., from
-      <tt>tty_update.c</tt> and <tt>lib_mvcur.c</tt></p>
-    </li>
+      <p>The ncurses library supports a compile-time feature
+      (enabled with the configure <code>--enable-check-size</code>
+      option) which simplifies initialization with terminals which
+      do not negotiate window (screen) size. This is done in
+      <code>setupterm</code>, by providing for using ANSI
+      cursor-position report (in user6/user7 terminfo capabilities)
+      to obtain the screen size if neither environment variables or
+      ioctl is used.</p>
 
-    <li>
-      <p id="getenv-fixes">the initialization functions now avoid
-      relying upon persistent data for the result from <a href=
-      "#getenv-check"><tt>getenv</tt></a></p>
+      <p>The ncurses test-program with options
+      &ldquo;<code>-E&nbsp;-T</code>&rdquo; demonstrates this
+      feature.</p>
     </li>
 
-    <li>
-      <p>scrolling is improved:</p>
-
-      <ul>
-        <li>a limit check in <tt>newline_forces_scroll</tt> handles
-        the case where the row is inside scroll-margins, but not at
-        the end.</li>
-
-        <li>
-          <p>improved loop limits in <tt>_nc_scroll_window</tt>
-          handle a case where the scrolled data is a pad which is
-          taller than the window.</p>
-        </li>
-      </ul>
-    </li>
+    <li>add functions to query tty-flags in
+    <code>SCREEN</code></li>
   </ul>
 
+  <p>This release drops compatibility with obsolete versions of
+  <a href="@HOMEPAGE@/tack/">tack</a>, e.g., pre-1.08</p>
+
   <h4><a name="h4-fixes-library" id="h4-fixes-library">Other
   improvements</a></h4>
 
-  <p>These are revised features:</p>
+  <p>These are improvements to existing features:</p>
 
   <ul>
     <li>
-      <p>used &ldquo;<tt>const</tt>&rdquo; in some prototypes
-      rather than <tt>NCURSES_CONST</tt> where X/Open Curses was
-      updated to do this, e.g., <tt>wscanw</tt>, <tt>newterm</tt>,
-      the terminfo interface. Also use &ldquo;<tt>const</tt>&rdquo;
-      for consistency in the termcap interface, which was withdrawn
-      by X/Open Curses in Issue 5 (2007). As of Issue 7, X/Open
-      Curses still lacks &ldquo;<tt>const</tt>&rdquo; for certain
-      return values, e.g., <a href=
-      "@HOMEPAGE@/man/curs_util.3x.html#h3-keyname_key_name">keyname</a>.</p>
-    </li>
-
-    <li>
-      <p>modified <a href=
-      "@HOMEPAGE@/man/curs_bkgd.3x.html#h3-bkgd"><tt>wbkgd</tt></a>
-      and <a href=
-      "@HOMEPAGE@/man/curs_bkgrnd.3x.html#h3-bkgrnd"><tt>wbkgrnd</tt></a>
-      to improve compatibility with SVr4 curses, changing the way
-      the window rendition is updated when the background character
-      is modified</p>
-    </li>
-
-    <li>
-      <p>improved terminfo write/read by modifying the fourth item
-      of the extended header to denote the number of valid strings
-      in the extended string table (see <a href=
-      "@HOMEPAGE@/man/term.5.html#h3-EXTENDED-STORAGE-FORMAT">term(5)</a>).</p>
-    </li>
-
-    <li>
-      <p>modified the initialization checks for mouse so that the
-      <a href=
-      "/ncurses/terminfo.src.html#tic-xterm_sm_1006"><tt>xterm+sm+1006</tt></a>
-      block will work with terminal descriptions not mentioning
-      <em>xterm</em>.</p>
-    </li>
-  </ul>
+      <p>In addition to the new, safer function
+      <code>tiparm_s</code>, ncurses adds checks to make the older
+      <code>tiparm</code>, <code>tparm</code> and
+      <code>tgoto</code> functions safer:</p>
 
-  <p>These were done to limit or ultimately deprecate features:</p>
+      <ul>
+        <li>
+          <p>the terminfo functions <code>tiparm</code> and
+          <code>tparm</code> ensure that the capability string
+          comes from the terminal description which ncurses loads,
+          rather than from random data which the application
+          happens to have.</p>
+        </li>
 
-  <ul>
-    <li>
-      <p>deprecated <a href=
-      "@HOMEPAGE@/NEWS.html#t970831">safe-sprintf</a>, since the
-      <tt>vsnprintf</tt> function, which does what was needed, was
-      standardized long ago.</p>
-    </li>
+        <li>
+          <p>the <code>tgoto</code> function disallows capabilities
+          which its analysis shows will attempt to use string
+          parameters.</p>
+        </li>
 
-    <li>
-      <p>marked <a href=
-      "@HOMEPAGE@/man/curs_printw.3x.html#h2-PORTABILITY"><tt>vwprintw</tt></a>
-      and <tt>vwscanw</tt> as deprecated; recommend using <a href=
-      "@HOMEPAGE@/man/curs_printw.3x.html"><tt>vw_printw</tt></a>
-      and <tt>vw_scanw</tt>, respectively.</p>
+        <li>
+          <p>ncurses uses internal functions which correspond to
+          <code>tiparm</code>, and <code>tgoto</code> which ensure
+          that the capability strings which are passed to these
+          functions come from the loaded terminal description.</p>
+        </li>
+      </ul>
     </li>
 
     <li>
-      <p>added deprecation warnings for internal functions called
-      by older versions of <a href=
-      "@HOMEPAGE@/tack.html">tack</a>.</p>
+      <p>improve check in <code>lib_tparm.c</code>, ensuring that a
+      char* fits into a <code>TPARM_ARG</code></p>
     </li>
 
     <li>
-      <p>removed unused <tt>_nc_import_termtype2</tt> function.</p>
+      <p>modify <code>_nc_syserr_abort</code> to use
+      <code>_nc_env_access</code>, rather than only checking root
+      uid</p>
     </li>
-  </ul>
 
-  <p>These are improvements to existing features:</p>
-
-  <ul>
     <li>
-      <p>check parameter of <a href=
-      "@HOMEPAGE@/man/curs_threads.3x.html">set_escdelay</a>,
-      return ERR if negative.</p>
+      <p>improve thread lock in <code>lib_trace.c</code></p>
     </li>
 
     <li>
-      <p>check parameter of <a href=
-      "@HOMEPAGE@/man/curs_threads.3x.html">set_tabsize</a>, return
-      ERR if not greater than zero</p>
+      <p>modify <code>flushinp</code> to use file descriptors in
+      <code>SCREEN</code>, rather than from <code>TERMINAL</code>,
+      and check if they are for a terminal, like SVr4</p>
     </li>
 
     <li>
-      <p>correct a status-check in _nc_read_tic_entry() so that if
-      reading a hex/b64 <a href=
-      "@HOMEPAGE@/man/ncurses.3x.html#h3-TERMINFO"><tt>$TERMINFO</tt></a>,
-      and the <a href=
-      "@HOMEPAGE@/man/ncurses.3x.html#h3-TERM"><tt>$TERM</tt></a>
-      does not match, fall-through to the compiled-in search
-      list.</p>
+      <p>modify <code>mcprint</code> to use file descriptor in
+      <code>SCREEN</code>, for consistency</p>
     </li>
 
     <li>
-      <p>amend check for <a href=
-      "@HOMEPAGE@/man/terminfo.5.html#h3-Predefined-Capabilities"><tt>
-      repeat_char</tt></a> to handle a case where setlocale() was
-      called after <a href=
-      "@HOMEPAGE@/man/curs_initscr.3x.html"><tt>initscr</tt></a></p>
+      <p>modify internal function <code>_nc_read_file_entry</code>
+      to show relevant filename in warnings</p>
     </li>
 
     <li>
-      <p>move macro for <a href=
-      "@HOMEPAGE@/man/curs_touch.3x.html"><tt>is_linetouched</tt></a>
-      inside <strong><tt>NCURSES_NOMACROS</tt></strong>
-      <em><tt>ifndef</tt></em>.</p>
+      <p>improve checks in internal function
+      <code>convert_string</code> for corrupt terminfo entry</p>
     </li>
 
     <li>
-      <p>use <tt>_nc_copy_termtype2</tt> rather than direct
-      assignment in <a href=
-      "@HOMEPAGE@/man/curs_terminfo.3x.html#h3-Initialization">setupterm</a>,
-      in case it is called repeatedly using fallback terminfo
-      descriptions</p>
+      <p>review/improve handling of out-of-memory conditions</p>
     </li>
 
     <li>
-      <p>improve workaround for Solaris wcwidth versus line-drawing
-      characters</p>
+      <p>limit delays to 30 seconds, i.e., padding delays in
+      terminfo, as well as <code>napms</code> and
+      <code>delay_output</code> functions</p>
     </li>
 
     <li>
-      <p>add checks in <a href=
-      "@HOMEPAGE@/man/resizeterm.3x.html"><tt>repair_subwindows</tt></a>
-      to keep the current position and scroll-margins inside the
-      resized subwindow.</p>
+      <p>fix reallocation loop for <code>vsnprintf</code> in
+      <code>_nc_sprintf_string</code> by copying the va_list
+      variable</p>
     </li>
 
     <li>
-      <p>correct a buffer-limit in <tt>write_entry.c</tt> for
-      systems that use caseless filenames.</p>
+      <p>modify <code>delscreen</code> to limit the windows which
+      it creates to just those associated with the screen</p>
     </li>
 
     <li>
-      <p>improved build-time utility <em>report_offsets</em>:</p>
-
-      <ul>
-        <li>
-          <p>add categories, e.g., "w" for wide-character, "t" for
-          threads to make the report more readable. Reorganized the
-          structures reported to make the categories more
-          apparent.</p>
-        </li>
-
-        <li>
-          <p>add <tt>NCURSES_GLOBALS</tt> and
-          <tt>NCURSES_PRESCREEN</tt> to report to show how similar
-          the different <em>libtinfo</em> configurations are.</p>
-        </li>
-      </ul>
+      <p>modify <code>endwin</code> to return an error if it is
+      called again without an intervening screen update</p>
     </li>
 
     <li>
-      <p>modified some header files to ensure that those include
-      necessary files except for the previously-documented
-      cases</p>
+      <p>modify <code>wenclose</code> to handle pads</p>
     </li>
 
     <li>
-      <p>added some traces in initialization to show whether a
-      fallback entry is used.</p>
+      <p>eliminate use of <code>PATH_MAX</code> in
+      <code>lib_trace.c</code></p>
     </li>
 
     <li>
-      <p>made minor optimization to reduce calls to
-      _nc_reserve_pairs</p>
+      <p>provide for any <code>CCHARW_MAX</code> greater than 1</p>
     </li>
   </ul>
 
